library Deprotect;

{$mode objfpc}{$H+}

uses
	SysUtils,
	JwaWindows;

procedure DeprotectCurrentProcess;
var
	ErrorCode: Dword;
begin
	ErrorCode:= SetSecurityInfo(
		GetCurrentProcess(),
		SE_KERNEL_OBJECT,
		DACL_SECURITY_INFORMATION,
		nil, nil, nil, nil
	);

	if ErrorCode <> ERROR_SUCCESS then
		raise Exception.CreateFmt(
			'Failed to deprotect the current process.'#13#10'%s',
			[SysErrorMessage(ErrorCode)]
		);

	WriteLn('The current process has been deprotected.');
end;

procedure ShowError(Message: String);
begin
	MessageBoxW(0, PWideChar(Unicodestring(Message)), nil, MB_ICONERROR);
end;

procedure CallWithErrorHandling(f: TProcedure);
begin
	try
		f();
	except
		on e: Exception do begin
			ShowError(e.Message);
			raise e;
		end;
	end;
end;

begin
	CallWithErrorHandling(@DeprotectCurrentProcess);
end.

